OpenVDB: NormalShader< GridT, SamplerType > Class Template Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
NormalShader< GridT, SamplerType > Class Template Reference

Color shader that treats the surface normal (x, y, z) as an RGB color. More...

`#include <openvdb/tools/RayTracer.h>`

Inheritance diagram for NormalShader< GridT, SamplerType >:

## Public Types
using | RayT = math::Ray<Real>

## Public Member Functions
| NormalShader (const GridT &grid)
| NormalShader (const NormalShader &)=default
| ~NormalShader () override=default
Film::RGBA | operator() (const Vec3R &xyz, const Vec3R &normal, const Vec3R &) const override
| Defines the interface of the virtual function that returns a RGB color.
BaseShader * | copy () const override

## Detailed Description

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>
class openvdb::v13_0::tools::NormalShader< GridT, SamplerType >

Color shader that treats the surface normal (x, y, z) as an RGB color.

The color can either be constant (if GridT = Film::RGBA which is the default) or defined in a separate Vec3 color grid. Use SamplerType to define the order of interpolation (default is zero order, i.e. closes-point).

## Member Typedef Documentation

## ◆ RayT

using RayT = math::Ray<Real>
| inherited

## Constructor & Destructor Documentation

## ◆ NormalShader() [1/2]

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>

NormalShader | ( | const GridT & | grid | ) |
| inline

## ◆ NormalShader() [2/2]

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>

NormalShader | ( | const NormalShader< GridT, SamplerType > & |  | ) |
| default

## ◆ ~NormalShader()

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>

~NormalShader | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ copy()

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>

BaseShader * copy | ( |  | ) | const
| inlineoverridevirtual

Implements BaseShader.

## ◆ operator()()

template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>

Film::RGBA operator() | ( | const Vec3R & | xyz,
|  | const Vec3R & | nml,
|  | const Vec3R & | dir ) const
| inlineoverridevirtual

Defines the interface of the virtual function that returns a RGB color.

Parameters

  xyz | World position of the intersection point.
  nml | Normal in world space at the intersection point.
  dir | Direction of the ray in world space.

Implements BaseShader.